##### リスト4.1 #####
#人工データ発生
set.seed(1)
x <- 1:10
y <- 20 + 0.24*100 * x * 60 / 240 + rnorm(10, 0, 2)

#散布図描画
plot(x, y)

#回帰直線計算
result <- lm(y~x)
result

#回帰直線描画
abline(result)

##### リスト4.2 #####
set.seed(1)
#人工データ発生
x = 1:30/3
y = x+rnorm(30,0,3)
dat = data.frame(x, y)

#線形回帰モデル当てはめ
lmresult <- lm(y~x)
#95%信頼区間計算
CIresult <- predict(lmresult, interval="confidence")
#95%予測区間計算
PIresult <- predict(lmresult, interval="prediction")

# データおよび回帰直線, 信頼区間, 予測区間描画
plot(x,y, ylim=range(PIresult))
lines(x, CIresult[,1])
lines(x, CIresult[,2], col="red")
lines(x, CIresult[,3], col="red")
lines(x, PIresult[,2], col="green")
lines(x, PIresult[,3], col="green")

##### リスト4.3 #####
library(MASS)
#線形重回帰モデル実行
result <- lm(medv~., data=Boston)
summary(result)


##### リスト4.4 #####
result2 <- step(result)
summary(result2)


##### リスト4.5 #####
#人工データ発生
set.seed(1)
n <- 30
x <- seq(0,5,length=n)
y <- (x-1)*(x-2)*(x-4) + rnorm(n, 0, 2)

#次数pの多項式回帰モデルを反復して推定・評価
for(p in 1:8){
  result <- lm(y ~ poly(x, p, raw=T))
  #各モデルに対してAIC, BIC計算
  print(c(p, AIC(result), BIC(result)))
}

# 選択された次数(3)で再度多項式回帰モデルを推定
p <- 3
result <- lm(y ~ poly(x, p, raw=T))
plot(x,y)
xx <- seq(0,5,length=101)

# 回帰曲線の描画
lines(xx, predict(object = result, newdata = data.frame(x=xx)))
# 真の曲線を破線で描画
lines(xx, (xx-1)*(xx-2)*(xx-4), lty=2)
