##### リスト5.1 #####
# 殺虫剤データ
x <- c(2.00, 2.64, 3.48, 4.59, 6.06, 8.00)
d <- c(2, 14, 20, 27, 41, 40)
m <- c(50, 49, 47, 50, 49, 50)
  
#ロジスティック回帰モデル適用
result <- glm(cbind(d, m-d)~x, family="binomial")
#回帰係数
result$coefficients

#説明変数xにおける確率πの推定値
predict(result, type="response")
    
#新しい観測点におけるπの推定値を計算
xx <- seq(0,10,length=101)
predict(result, newdata=data.frame(x=xx), type="response")


##### リスト5.2 #####
# 喫煙データ
x <- c(2, 6, 6, 10, 14, 19, 22, 26, 30)
y <- c(0, 0, 0, 0, 1, 0, 1, 1, 1)

#ロジスティック回帰モデル適用
result <- glm(y~x, family="binomial")
#回帰係数
result$coefficients

#説明変数xにおける確率πの推定値
predict(result, type="response")

#新しい観測点におけるπの推定値を計算
xx <- seq(0,32,length=101)
predict(result, newdata=data.frame(x=xx), type="response")


##### リスト5.3 #####
library(ISLR)

#ロジスティック回帰モデル適用
result <- glm(default~student+balance+income, data=Default, family="binomial")

#分析結果の出力
summary(result)


##### リスト5.4 #####
# リスト5.3からの続き
library(caret)

# 事後確率の予測値計算
pred.result <- predict(result, type="response")

# 閾値によるラベル設定
pred.label <- ifelse(pred.result >= 0.5, "Yes", "No")

# factor型へ変換
pred.label <- factor(pred.label, levels=c("No", "Yes"))

# 混同行列計算
confusion <- confusionMatrix(pred.label, Default$default)

# 混同行列出力
confusion$table


##### リスト5.5 #####
# リスト5.3からの続き
library(ROCR)

# ROC描画のための準備
pred.result2 <- prediction(pred.result, Default$default)
pred.result3 <- performance(pred.result2, measure="tpr", x.measure="fpr")
#ROC描画
plot(pred.result3)

#AUC出力
auc <- performance(pred.result2, measure="auc")
auc@y.values


##### リスト5.6 #####
# 多項ロジスティック回帰モデル
library(nnet)
result <- multinom(Species~., data=iris)
result

#判別確率
result$fitted.values


##### リスト5.7 #####
# リスト5.6からの続き
library(caret)
# 判別ラベル計算
pred.label <- predict(result)
# 混同行列計算
confusion <- confusionMatrix(pred.label, iris$Species)
# 混同行列出力
confusion$table



