##### リスト7.1 #####
#パラメータ設定
set.seed(0)
n <- 10000
mu1 <- 40; mu2 <- 70
sig1 <- 10; sig2 <- 5
rate <- 0.5

#乱数発生
x1 <- rnorm(n, mean=mu1, sd = sig1)
x2 <- rnorm(n, mean=mu2, sd = sig2)
z <- rbinom(n, size=1, prob=rate)
x <- x1*z + x2*(1-z) 
#ヒストグラム描画
hist(x, breaks=30, col="lightblue")
 
#EMアルゴリズムによるパラメータ推定 (mixtools)
library(mixtools)
fit <- normalmixEM(x,2)
summary(fit)

# 各成分の密度関数を描画
plot(fit, whichplots = 2)

  
##### リスト7.2 #####
library(mixtools)
library(mclust)
data(acidity)

#EMアルゴリズムによるパラメータ推定 (mixtools)
fit <- normalmixEM(acidity, 2)
plot(fit,2)
summary(fit)

#どちらの成分に含まれるかの確率(gamma)
fit$posterior[1:5,]

  
##### リスト7.3 #####
# 2変量混合正規分布モデルの当てはめ
fit <- mvnormalmixEM(faithful,k=2)
summary(fit)

#データと分布の等高線描画
plot(fit,2)

    
##### リスト7.4 #####
data(NOdata)
#混合回帰による推定
res <- regmixEM(NOdata$Equivalence, NOdata$NO, k=2)
#各成分の回帰係数
res$beta

#成分数の選択
res = regmixmodel.sel(NOdata$Equivalence, NOdata$NO, k = 3)
res
    